<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Task 45.50 - Danh sách đơn hàng</title>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <!-- Import Datatable sau jquery -->
    <!-- Import them style bootstrap cho datatable -->
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
</head>

<body class="hold-transition sidebar-mini layout-fixed">
    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">Order List</a>
                </li>
            </ul>

            <!-- Right navbar links -->
            <ul class="navbar-nav ml-auto">
                <li class="nav-item">
                    <a class="nav-link" data-widget="fullscreen" href="#" role="button">
                        <i class="fas fa-expand-arrows-alt"></i>
                    </a>
                </li>

            </ul>
        </nav>
        <!-- /.navbar -->
        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="#" class="brand-link">
                <span class="brand-text font-weight-light">Devcamp</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class
         with font-awesome or any other icon font library -->
                        <li class="nav-item menu-open">
                            <a href="#" class="nav-link active">
                                <i class="nav-icon fas fa-tachometer-alt"></i>
                                <p>
                                    Dashboard
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>
                            <ul class="nav nav-treeview">
                                <li class="nav-item">
                                    <a href="./index.html" class="nav-link active">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Dashboard v1</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="./index2.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Dashboard v2</p>
                                    </a>
                                </li>
                                <li class="nav-item">
                                    <a href="./index3.html" class="nav-link">
                                        <i class="far fa-circle nav-icon"></i>
                                        <p>Dashboard v3</p>
                                    </a>
                                </li>
                            </ul>
                        </li>
                        <li class="nav-item">
                            <a href="pages/widgets.html" class="nav-link">
                                <i class="nav-icon fas fa-th"></i>
                                <p>
                                    Widgets
                                    <span class="right badge badge-danger">New</span>
                                </p>
                            </a>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>
        <!-- Content Wrapper. Contains page content -->
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <div class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                            <h1 class="m-0">Danh sách đơn hàng</h1>
                        </div><!-- /.col -->
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active"> Order list</li>
                            </ol>
                        </div><!-- /.col -->
                    </div><!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content-header -->
            <!-- Main content -->
            <section class="content">
                <div class="container-fluid">
                    <div class="jumbotron container">
                        <div class="row form-group">
                            <div class="col-md-5 row">
                                <div class="col-md-6 text-center">
                                    <label class="form-group mx-2">Trạng thái Order</label>
                                </div>
                                <div class="col-md-6">
                                    <select class="form-control" id="sel-status">
                                        <option value="all">All</option>
                                        <option value="open">Open</option>
                                        <option value="confirmed">Confirmed</option>
                                        <option value="cancel">Cancel</option>
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-5 row">
                                <div class="col-md-6 text-center">
                                    <label class="form-group mx-2">Loại Pizza</label>
                                </div>
                                <div class="col-md-6">
                                    <select class="form-control" id="sel-pizza">
                                        <option value="all">All</option>
                                        <option value="hawai">Hawai</option>
                                        <option value="bacon">Bacon</option>
                                        <option value="seafood">Seafood</option>
                                    </select>
                                </div>
                            </div>
                            <div class="col-md-2 row">
                                <div class="col-md-12 text-right">
                                    <button class="btn btn-success" id="btn-filter">Lọc</button>
                                </div>
                            </div>
                        </div>
                    </div>
                    <table class="table table-bordered table-striped table-hover" id="table-order">
                        <thead>
                            <tr>
                                <th>Order ID</th>
                                <th>Kích cỡ Combo</th>
                                <th>Loại pizza</th>
                                <th>Nước uống</th>
                                <th>Thành tiền</th>
                                <th>Họ và tên</th>
                                <th>Số điện thoại</th>
                                <th>Trạng thái</th>
                                <th>Action</th>
                            </tr>
                        </thead>
                    </table>
                </div>
            </section>
        </div>
        <footer class="main-footer">
            <strong>Copyright &copy; 2022 Devcamp</strong>
            All rights reserved.
            <div class="float-right d-none d-sm-inline-block">
                <b>Version</b> 1.0.0
            </div>
        </footer>
        <!-- /.content -->
        <!-- /.content-wrapper -->
        <!-- jQuery -->
        <script src="plugins/jquery/jquery.min.js"></script>
        <!-- Bootstrap 4 -->
        <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
        <!-- AdminLTE App -->
        <script src="dist/js/adminlte.js"></script>
        <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
        <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

        <script>
            "use strict";
            $(document).ready(function () {
                /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
                var gDataOrders = []; //Khai báo biến mảng (biến toàn cục) để chứa thông tin đơn hàng
                const gORDER = ["orderId", "kichCo", "loaiPizza", "idLoaiNuocUong", "thanhTien", "hoTen", "soDienThoai", "trangThai", "action"];
                var gId;
                var gOrderId;
                //Khai báo các cột của datatable
                const gCOLUMN_ORDER_ID = 0;
                const gCOLUMN_KICH_CO = 1;
                const gCOLUMN_LOAI_PIZZA = 2;
                const gCOLUMN_ID_LOAI_NUOC_UONG = 3;
                const gCOLUMN_THANH_TIEN = 4;
                const gCOLUMN_HO_TEN = 5;
                const gCOLUMN_SO_DIEN_THOAI = 6;
                const gCOLUMN_TRANG_THAI = 7;
                const gCOLUMN_ACTION = 8;
                //Định nghĩa table - chưa có data
                $("#table-order").DataTable({
                    "columns": [
                        { "data": gORDER[gCOLUMN_ORDER_ID] },
                        { "data": gORDER[gCOLUMN_KICH_CO] },
                        { "data": gORDER[gCOLUMN_LOAI_PIZZA] },
                        { "data": gORDER[gCOLUMN_ID_LOAI_NUOC_UONG] },
                        { "data": gORDER[gCOLUMN_THANH_TIEN] },
                        { "data": gORDER[gCOLUMN_HO_TEN] },
                        { "data": gORDER[gCOLUMN_SO_DIEN_THOAI] },
                        { "data": gORDER[gCOLUMN_TRANG_THAI] },
                        { "data": gORDER[gCOLUMN_ACTION] },
                    ],
                    //Ghi đè nội dung của cột Action, chuyển thành button chi tiết
                    "columnDefs": [
                        {
                            "targets": gCOLUMN_ACTION,
                            "defaultContent": "<button class='btn-detail btn btn-primary'>Chi tiết</button>"
                        }]
                });
                /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
                onPageLoading();
                //gắn event handler(sự kiện) cho nút Chi Tiết
                $("#table-order").on("click", ".btn-detail", function () {
                    onBtnDetailClick(this); //this là button được ấn
                });
                //gán event handler(sự kiện) cho nút lọc
                $("#btn-filter").on("click", function () {
                    onBtnFilterDataClick();
                });
                /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
                function onPageLoading() {
                    //lấy data từ server
                    $.ajax({
                        url: "http://42.115.221.44:8080/devcamp-pizza365/orders",
                        type: "GET",
                        dataType: 'json',
                        success: function (responseObject) {
                            gDataOrders = responseObject;
                            console.log(gDataOrders);
                            //gọi hàm load(đổ) dữ liệu vào bảng
                            loadDataToTable(gDataOrders);
                        },
                        error: function (error) {
                            console.assert(error.responseText);
                        }
                    });
                }
                /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
                //Hàm filter Data
                function onBtnFilterDataClick() {
                    "use strict";
                    var vStatus = $("#sel-status").val();
                    var vPizzaType = $("#sel-pizza").val();
                    var vDataFilter = gDataOrders.filter(function (paramOrder, index) {
                        return (vStatus === "all" || (paramOrder.trangThai != null && vStatus.toUpperCase() === paramOrder.trangThai.toUpperCase()))
                            && (vPizzaType === "all" || (paramOrder.loaiPizza != null && vPizzaType.toUpperCase() === paramOrder.loaiPizza.toUpperCase()))
                    });
                    //gọi hàm load(đổ) dữ liệu vào (table) bảng
                    loadDataToTable(vDataFilter);
                }
                //Hàm xử lý load(đổ) dữ liệu vào bảng
                function loadDataToTable(paramResponseObject) {
                    "use strict";
                    var vUserTable = $("#table-order").DataTable();
                    //Xoá toàn bộ dữ liệu đang có của bảng
                    vUserTable.clear();
                    //Cập nhật data cho bảng
                    vUserTable.rows.add(paramResponseObject);
                    //Cập nhật lại giao diện hiển thị bảng
                    vUserTable.draw();
                }
                //Hàm xử lý khi ấn nút Chi Tiết
                function onBtnDetailClick(paramElement) {
                    "use strict";
                    var vRowSelected = $(paramElement).closest("tr");
                    var vTable = $("#table-order").DataTable();
                    var vDataRow = vTable.row(vRowSelected).data();
                    gId = vDataRow.id;
                    gOrderId = vDataRow.orderId;
                    console.log("ID: " + gId);
                    console.log("Order ID: " + gOrderId);
                }
            });
            
        </script>
    </body>
</html>